--
-- Created by IntelliJ IDEA.
-- User: admin
-- Date: 5/07/2014
-- Time: 10:18 PM
-- To change this template use File | Settings | File Templates.
--

local Ace = LibStub("AceAddon-3.0")
local Comergy2 = Ace:GetAddon("Comergy2")
--noinspection UnusedDef
local Comergy2_Energy = Comergy2:NewModule("Comergy2_Energy")


function Comergy2_Energy:OnInitialize()
    self.POWER_TYPE = ENERGY

    self.frame = CreateFrame("Frame", "Comergy2_Energy", Comergy2.frame)
    self.frame.priority = 2
    self.frame:Show()

    local h = 10 + Comergy2.db.profile.spacing
    self.frame:SetHeight(h)
--    self.frame:SetPoint("LEFT", Comergy2.frame, "LEFT", Comergy2.db.profile.spacing, 0)
--    self.frame:SetPoint("RIGHT", Comergy2.frame, "RIGHT", -Comergy2.db.profile.spacing, 0)

    self.frame.h = h
    self.frame:SetScript("OnUpdate",
        function(...)
            self:OnUpdate(...)
        end)

    self.frame.priority = 2

    Comergy2:RegisterFrame(self.frame, self:GetName())

    self.bars = {}

    local bar = CreateFrame("StatusBar", "Comergy2_EnergyBar", self.frame)
    local max = UnitPowerMax("player", self.POWER_TYPE)
    bar:SetMinMaxValues(0, max > 0 and max or 100)
    local off = Comergy2.db.profile.spacing
    bar:SetPoint("TOPLEFT", off, -off/2)
    bar:SetPoint("BOTTOMRIGHT", -off, off/2)
    bar:SetOrientation("HORIZONTAL")
--    bar:SetRotatesTexture(false)

    self.bars[1] = bar

    bar.bg = bar:CreateTexture(nil, "BACKGROUND")
    bar.bg:SetTexture(0.5, 0.0, 1.0, 0.3)
    bar.bg:SetAllPoints()

    self:UpdateTextures()
    self:ColorBars()
end

function Comergy2_Energy:OnEnable()
--    Comergy2:Print(self:GetName(), "enable")
end

function Comergy2_Energy:OnDisable()
--    Comergy2:Print(self:GetName(), "disable")
end

function Comergy2_Energy:OnUpdate()
    local pwr = UnitPower("player", self.POWER_TYPE)
    self.bars[1]:SetValue(pwr)
end

function Comergy2_Energy:UpdateTextures()
    local tex = Comergy2.SM3:Fetch("statusbar", Comergy2.db.profile.texture)
    for i = 1, #self.bars do
        self.bars[i]:SetStatusBarTexture(tex)
    end
end

function Comergy2_Energy:RefreshConfig()
end

function Comergy2_Energy:IsStable() return true end

function Comergy2_Energy:ColorBars()
    local clr
    for i = 1, #self.bars do
        clr = { 0.0, 1.0, 0.0 }
        self.bars[i]:SetStatusBarColor(clr[1], clr[2], clr[3])
    end
end
